using Edu.Common.Enum;
using Edu.Model.Entity.Web;
using Edu.Model.ViewModel.Web;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using VT.FW.DB.Dapper;

namespace Edu.Repository.Web
{
    /// <summary>
    /// 教师团队管理仓储层
    /// </summary>
    public class RB_Web_TeacherRepository : BaseRepository<RB_Web_Teacher>
    {
        /// <summary>
        /// 获取教师团队分页列表
        /// </summary>
        /// <param name="pageIndex">页码</param>
        /// <param name="pageSize">每页显示调试</param>
        /// <param name="rowsCount">总条数</param>
        /// <param name="query">查询条件</param>
        /// <returns></returns>
        public List<RB_Web_Teacher_ViewModel> GetWebTeacherPageRepository(int pageIndex, int pageSize, out long rowsCount, RB_Web_Teacher_ViewModel query)
        {
            rowsCount = 0;
            var parameters = new DynamicParameters();
            StringBuilder builder = new StringBuilder();
            builder.Append(@"
SELECT A.* 
FROM RB_Web_Teacher AS A
WHERE 1=1
");
            if (query == null)
            {
                return new List<RB_Web_Teacher_ViewModel>();
            }
            else
            {
                if (query.Group_Id > 0)
                {
                    builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_Teacher_ViewModel.Group_Id), query.Group_Id);
                }
                if (!string.IsNullOrEmpty(query.Name))
                {
                    builder.AppendFormat(" AND A.{0} LIKE @Name ", nameof(RB_Web_Teacher_ViewModel.Name));
                    parameters.Add("Name", "%" + query.Name.Trim() + "%");
                }
                if (query.Status >= 0)
                {
                    builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_Teacher_ViewModel.Status), (int)query.Status);
                }
                if (query.Type > 0)
                {
                    builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_Teacher_ViewModel.Type), query.Type);
                }
            }
            builder.AppendFormat(" ORDER BY A.{0} DESC ", nameof(RB_Web_Teacher_ViewModel.Id));
            return GetPage<RB_Web_Teacher_ViewModel>(pageIndex, pageSize, out rowsCount, builder.ToString(), parameters).ToList();
        }

        /// <summary>
        /// 获取教师团队列表
        /// </summary>
        /// <param name="query">查询条件</param>
        /// <returns></returns>
        public List<RB_Web_Teacher_ViewModel> GetWebTeacherListRepository(RB_Web_Teacher_ViewModel query)
        {
            var parameters = new DynamicParameters();
            StringBuilder builder = new StringBuilder();
            builder.Append(@"
SELECT A.* 
FROM RB_Web_Teacher AS A
WHERE 1=1
");
            builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_Teacher_ViewModel.Status), (int)DateStateEnum.Normal);
            if (query == null)
            {
                return new List<RB_Web_Teacher_ViewModel>();
            }
            else
            {
                if (query.Group_Id > 0)
                {
                    builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_Teacher_ViewModel.Group_Id), query.Group_Id);
                }
                if (!string.IsNullOrEmpty(query.Name))
                {
                    builder.AppendFormat(" AND A.{0} LIKE @Name ", nameof(RB_Web_Teacher_ViewModel.Name));
                    parameters.Add("Name", "%" + query.Name.Trim() + "%");
                }
                if (query.Type > 0)
                {
                    builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_Teacher_ViewModel.Type), query.Type);
                }
            }
            return Get<RB_Web_Teacher_ViewModel>(builder.ToString()).ToList();
        }
    }
}
